#ifndef Threads_h //Prevent Duplicates
#define Threads_h


#include <scheduler.h>
//#include <stdio.h>

const int32 THREAD_LOW = 5;
const int32 THREAD_NORM = 20;
const int32 THREAD_HIGH = 50;

class ThreadPrimitive { 
public: 

  ThreadPrimitive(int32 priority = B_LOW_PRIORITY, 
    const char *name = 0) 
    :  scanThread(-1), 
       priority(priority), 
       name(name) 
    {} 

  virtual ~ThreadPrimitive() 
    {
    	//printf("Killing thread %s...\n");
    	kill=true;
    	status_t x;
    	if (wait_for_thread(scanThread,&x)==B_INTERRUPTED) {
    		kill_thread(scanThread);
    	}
    	//printf("...killed.\n");
    } 

    
  void Go() 
    { 
      kill=false;
      scanThread = spawn_thread(&ThreadPrimitive::RunBinder, 
        name ? name : "UntitledThread", priority, this); 
       resume_thread(scanThread); 
    } 
    
  virtual void RunThread() = 0; 

private: 

  static status_t RunBinder(void *castToThis) 
    { 
      // In this call we do the dirty casting work, making 
      // the rest of the interfaces fully typed and clean 

      ThreadPrimitive *self = (ThreadPrimitive *)castToThis; 
      self->RunThread(); 

	  return B_OK; 
  } 

protected: 

  bool kill;
  thread_id scanThread; 
  int32 priority; 

private: 
  const char *name;  // only valid in the constructor and in 
                     // the Go call 
}; 


#endif //Threads_h

